import React from 'react';
import { css } from '@patternfly/react-styles';
import styles from '../../../../@patternfly/patternfly/components/Table/table.css.js';
import ActionsColumn from '../../ActionsColumn';

export default (function (actions) {
  return function (label, _ref) {
    var rowIndex = _ref.rowIndex,
        _ref$column$extraPara = _ref.column.extraParams,
        dropdownPosition = _ref$column$extraPara.dropdownPosition,
        dropdownDirection = _ref$column$extraPara.dropdownDirection;
    return {
      className: css(styles.tableAction),
      isVisible: true,
      children: React.createElement(
        ActionsColumn,
        {
          items: actions,
          dropdownPosition: dropdownPosition,
          dropdownDirection: dropdownDirection,
          rowId: rowIndex
        },
        label
      )
    };
  };
});