import React from 'react';
import { Table, TableHeader, TableBody } from '@redallen-patternfly/react-table';

class CollapsibleTable extends React.Component {
  constructor(props) {
    super(props)
    this.state = {
      columns: [
        { title: 'Header cell' },
        'Branches',
        { title: 'Pull requests' },
        'Workspaces',
        {
          title: 'Last Commit'
        }],
      rows: [{
        cells: ['one', 'two', 'three', 'four', 'five'],
      }, {
        isOpen: true,
        cells: ['parent - 1', 'two', 'three', 'four', 'five'],
      }, {
        parent: 1,
        cells: ['child - 1'],
      }, {
        isOpen: false,
        cells: ['parent - 2', 'two', 'three', 'four', 'five'],
      }, {
        isOpen: false,
        parent: 3,
        cells: ['child and parent'],
      }, {
        parent: 4,
        cells: ['child - 2'],
      }, {
        isOpen: false,
        cells: ['parent - 3', 'two', 'three', 'four', 'five'],
      }, {
        parent: 6,
        cells: ['child - 3'],
      }, {
        parent: 6,
        cells: ['child - 4'],
      }]
    };
    this.onCollapse = this.onCollapse.bind(this);
  }

  onCollapse(event, rowKey, isOpen) {
    const { rows } = this.state;
    /** 
     * Please do not use rowKey as row index for more complex tables.
     * Rather use some kind of identifier like ID passed with each row.
    */
    rows[rowKey].isOpen = isOpen;
    this.setState({
      rows
    });
  }

  render() {
    const { columns, rows } = this.state;

    return (
      <Table caption="Collapsible table" onCollapse={this.onCollapse} rows={rows} cells={columns}>
        <TableHeader />
        <TableBody />
      </Table>
    );
  }
}

export default CollapsibleTable;
